# instead of pure Perl this script uses curl for web requests. 
# this requires curl to be installed on your computer and available from the command line. It ships with linux, and probably Mac OS X. You can get it for Windows, but you'll need to add it to your path yourself.
# the google qpxExpress flights API needs an API key and it costs money so I've removed mine. You can try the service for free.

use strict; 
use warnings; 

use JSON;

open(FLIGHTS, ">flightsTable.txt");

my @origins = ('LHR', 'EDI', 'CWL', 'BFS', 'MAN', 'BHD', 'GLA', 'LBA', 'DSA', 'LPL', 'NCL', 'BRS', 'EXT', 'NWI', 'ABZ', 'DUB');
my @destinations = ('CPT', 'LOS', 'CAI', 'EZE', 'SCL', 'BOG', 'YYC', 'IAH', 'MEX', 'BOM', 'KUL', 'MNL', 'CTU', 'CTS', 'ICN', 'LED', 'OVB', 'ULN');

#foreach my $originCode (@origins) {
	my $originCode = "LHR";
	foreach my $destinationCode (@destinations) {
		print "Getting $originCode to $destinationCode flights.\n";
		my $request = "{ 'request': { 'slice': [ { 'origin': '$originCode', 'destination': '$destinationCode', 'date': '2014-11-25' } ], 'passengers': { 'adultCount': 1 }, 'solutions': 1, 'refundable': false } }";

		my $nonstopRequest = "{ 'request': { 'slice': [ { 'origin': '$originCode', 'destination': '$destinationCode', 'date': '2014-11-25', 'maxConnectionDuration': 120 } ], 'passengers': { 'adultCount': 1 }, 'solutions': 1, 'refundable': false } }";
		
		my $curlCommand = 'curl -s -k -d "'.$nonstopRequest.'" --header "Content-Type: application/json" https://www.googleapis.com/qpxExpress/v1/trips/search?prettyPrint=false^&key=SORRY_THE_KEY_COSTS_MONEY_TO_USE_GET_YOUR_OWN';
		#print $curlCommand;
		my $JSONResponse = qx($curlCommand);


		my $decodedJSON = decode_json($JSONResponse);


		my $price = $decodedJSON->{'trips'}{'tripOption'}[0]{'saleTotal'};
		if ($price) {
			my $duration = $decodedJSON->{'trips'}{'tripOption'}[0]{'slice'}[0]{duration};
			my $durationString = $duration/60 - ($duration%60)/60 ."h". $duration%60 . "m";
			my @airportsArray = @{ $decodedJSON->{'trips'}{'data'}{'airport'} };

			print FLIGHTS $price . "\t";
			print FLIGHTS $duration . " = ".  $durationString . "\t";
			foreach my $airport ( @airportsArray ) {
				if ($airport->{'code'} ne $originCode && $airport->{'code'} ne $destinationCode) {
					print FLIGHTS $airport->{'code'} . " = ". $airport->{'name'} . ", ";
				}
			}

		}
		else {
			print FLIGHTS "NA\tNA\tNA";
		}
		print FLIGHTS "\t";
	}
#print FLIGHTS "\n";
#}

close FLIGHTS;